#!/bin/bash

# Navigate through all directories and subdirectories
find . -type d | while read -r directory; do
    # Navigate to each directory
    cd "$directory"
    
    # Find all .gz files in the current directory
    for gz_file in *.gz; do
        if [ -f "$gz_file" ]; then
            # Create names for the jsonl and json files based on the gz file name
            jsonl_file="${gz_file%.gz}"
            json_file="${jsonl_file%.jsonl}.json"

            # Unzip the .gz file to .jsonl
            gunzip -c "$gz_file" > "$jsonl_file"

            # Extract the first line from the .jsonl file and pretty print to .json file
            head -n 1 "$jsonl_file" | jq '.' > "$json_file"
        fi
    done

    # Return to the parent directory
    cd -
done
